import sys,termios,fcntl,os
import select

class cKeybInput:
   def __init__(self):
      self.fd,self.oldterm,self.oldflags=None,None,None
   def __del__(self):
      if self.fd is not None: 
         self.stop()
   def isOn(self):
      return self.fd is not None
   def stop(self):
      if self.fd is not None:
         termios.tcsetattr(self.fd,termios.TCSAFLUSH,self.oldterm)
         fcntl.fcntl(self.fd,fcntl.F_SETFL,self.oldflags)
         self.fd=None
   def start(self):
      if self.fd is not None: self.stop()
      self.fd=sys.stdin.fileno()
      # Set terminal (saving old settings)
      self.oldterm=termios.tcgetattr(self.fd)
      newattr=self.oldterm[:] # make a copy
      newattr[3]=newattr[3] & ~termios.ICANON & ~termios.ECHO
      termios.tcsetattr(self.fd,termios.TCSANOW,newattr)
      self.oldflags=fcntl.fcntl(self.fd,fcntl.F_GETFL)
      fcntl.fcntl(self.fd,fcntl.F_SETFL,self.oldflags | os.O_NONBLOCK)
   def getChar(self):
      if self.fd is None: self.start()
      charin=''
      try:
         while True:
            ch=sys.stdin.read(1)
            charin=ch.upper()
      except IOError:
         pass
      return charin
   def getStr(self,prompt,timeout=60):
      """
         Get user entered stripped string (within timeout)
         If timeout (or only CR), return ''
      """
      rets=''
      ison=self.isOn()
      if ison: self.stop()
      print prompt
      print "Write+CR > ",
      sys.stdout.flush()
      r,_,_=select.select([sys.stdin],[],[],timeout)
      if r:
         rets=sys.stdin.readline()
      if ison: self.start()
      return rets.strip()



def main():
   ckb=cKeybInput()   
   try:
      while True:
         c=ckb.getchar()
         if c:
            print ord(c)
            if ord(c)==27:
               v=ckb.getstr("Enter somethin",10)
               print "Got: '%s'"%(v,)
   except:
      ckb.stop()

if __name__ == "__main__": main()      
